program Generic;

{$APPTYPE CONSOLE}

uses Windows, Messages;

const
  AppWndClassName = 'GenericWin32Class';

function WindowProc(hWnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM):
  LRESULT; stdcall;
var
  PS : TPaintStruct;
begin
  Result := 0;
  case Msg of
    WM_CREATE:
      exit;
    WM_PAINT:
    begin
      Windows.BeginPaint(hWnd,PS);
      Windows.EndPaint(hWnd,PS);
    end;
    WM_DESTROY:
    begin
      Windows.PostQuitMessage(0);
      exit;
    end;
  end;
  Result := Windows.DefWindowProc(hWnd, Msg, WParam, LParam);
end;

function WinMain:LongInt;
var
  hWin:  HWnd;
  Msg:   TMsg;
  WndClass: TWndClass;
begin
  Result := 0;
  // ===================================================================
  WndClass.style := CS_HREDRAW or CS_VREDRAW;
  WndClass.lpfnWndProc := @WindowProc;
  WndClass.cbClsExtra := 0;
  WndClass.cbWndExtra := 0;
  WndClass.hInstance := Windows.GetModuleHandle(nil);
  WndClass.hIcon := Windows.LoadIcon(0, IDI_APPLICATION);
  WndClass.hCursor := Windows.LoadCursor(0, IDC_ARROW);
  WndClass.hbrBackground := Windows.GetStockObject(WHITE_BRUSH);
  WndClass.lpszMenuName := nil;
  WndClass.lpszClassName := AppWndClassName;
  if Windows.RegisterClass(WndClass) = 0 then exit;
  // ===================================================================
  hWin := Windows.CreateWindow(AppWndClassName,
    '   Win32',
    WS_OVERLAPPEDWINDOW,
    30, 30, 640, 480,
    0, 0, HInstance, nil);
  if hWin = 0 then exit;
  // ===================================================================
  Windows.ShowWindow(hWin, SW_SHOWNORMAL);
  Windows.UpdateWindow(hWin);
  while Windows.GetMessage(Msg, 0, 0, 0) do
  begin
    Windows.TranslateMessage(Msg);
    Windows.DispatchMessage(Msg);
  end;
  // =====================================================================
  Result := Msg.wParam;
end;

begin
  Halt(WinMain);
end.

