#include <../source/TAL/objbase.h>

#include "winlib_common.h"

char_p	V_GLOBAL
uiKeyscan2Name(unsigned scan)
{
	char *name;

#define	MATCH_SCAN(scan_name) \
	case sc_##scan_name: name = #scan_name; break;

	switch(scan)
	{
		MATCH_SCAN(escape)
		MATCH_SCAN(f1)
		MATCH_SCAN(f2)
		MATCH_SCAN(f3)
		MATCH_SCAN(f4)
		MATCH_SCAN(f5)
		MATCH_SCAN(f6)
		MATCH_SCAN(f7)
		MATCH_SCAN(f8)
		MATCH_SCAN(f9)
		MATCH_SCAN(f10)
		MATCH_SCAN(f11)
		MATCH_SCAN(f12)
		MATCH_SCAN(print)
		MATCH_SCAN(scroll_lock)
		MATCH_SCAN(pause)

		MATCH_SCAN(grave)
		MATCH_SCAN(1)
		MATCH_SCAN(2)
		MATCH_SCAN(3)
		MATCH_SCAN(4)
		MATCH_SCAN(5)
		MATCH_SCAN(6)
		MATCH_SCAN(7)
		MATCH_SCAN(8)
		MATCH_SCAN(9)
		MATCH_SCAN(0)
		MATCH_SCAN(minus)
		MATCH_SCAN(equal)
		MATCH_SCAN(backslash)
		MATCH_SCAN(backspace)

		MATCH_SCAN(tab)
		MATCH_SCAN(q)
		MATCH_SCAN(w)
		MATCH_SCAN(e)
		MATCH_SCAN(r)
		MATCH_SCAN(t)
		MATCH_SCAN(y)
		MATCH_SCAN(u)
		MATCH_SCAN(i)
		MATCH_SCAN(o)
		MATCH_SCAN(p)
		MATCH_SCAN(lbracket)
		MATCH_SCAN(rbracket)
		MATCH_SCAN(enter)

		MATCH_SCAN(caps_lock)
		MATCH_SCAN(a)
		MATCH_SCAN(s)
		MATCH_SCAN(d)
		MATCH_SCAN(f)
		MATCH_SCAN(g)
		MATCH_SCAN(h)
		MATCH_SCAN(j)
		MATCH_SCAN(k)
		MATCH_SCAN(l)
		MATCH_SCAN(semicolon)
		MATCH_SCAN(apostrophe)

		MATCH_SCAN(lshift)
		MATCH_SCAN(z)
		MATCH_SCAN(x)
		MATCH_SCAN(c)
		MATCH_SCAN(v)
		MATCH_SCAN(b)
		MATCH_SCAN(n)
		MATCH_SCAN(m)
		MATCH_SCAN(comma)
		MATCH_SCAN(period)
		MATCH_SCAN(slash)
		MATCH_SCAN(rshift)

		MATCH_SCAN(lcontrol)
		MATCH_SCAN(lsuper)
		MATCH_SCAN(lalt)
		MATCH_SCAN(space)
		MATCH_SCAN(ralt)
		MATCH_SCAN(rsuper)
		MATCH_SCAN(menu)
		MATCH_SCAN(rcontrol)

		MATCH_SCAN(insert)
		MATCH_SCAN(home)
		MATCH_SCAN(prior)
		MATCH_SCAN(delete)
		MATCH_SCAN(end)
		MATCH_SCAN(next)

		MATCH_SCAN(up)
		MATCH_SCAN(down)
		MATCH_SCAN(left)
		MATCH_SCAN(right)

		MATCH_SCAN(num_lock)
		MATCH_SCAN(kp_slash)
		MATCH_SCAN(kp_multiply)
		MATCH_SCAN(kp_subtract)
		MATCH_SCAN(kp_home)
		MATCH_SCAN(kp_up)
		MATCH_SCAN(kp_prior)
		MATCH_SCAN(kp_add)
		MATCH_SCAN(kp_left)
		MATCH_SCAN(kp_begin)
		MATCH_SCAN(kp_right)
		MATCH_SCAN(kp_end)
		MATCH_SCAN(kp_down)
		MATCH_SCAN(kp_next)
		MATCH_SCAN(kp_enter)
		MATCH_SCAN(kp_insert)
		MATCH_SCAN(kp_delete)

		MATCH_SCAN(lbutton)
		MATCH_SCAN(mbutton)
		MATCH_SCAN(rbutton)

		MATCH_SCAN(wheelup)
		MATCH_SCAN(wheeldown)

	    default: name = "unknown";
	}
	return name;

#undef	MATCH_SCAN
}

unsigned V_GLOBAL
uiName2Keyscan(char *name)
{
	unsigned code;
	if(!name || !*name)
		return sc_unknown;
	for(code = 0;code < sc_maxcode;code++)
		if(!strcasecmp(name,uiKeyscan2Name(code)))
			return code;
	return sc_unknown;
}

vsize_t V_CALL
archWinQueued(arch_window_p wnd)
{
	archWinPoll(wnd,false);
	return eventDeqCount(wnd->msg_que);
}

ui_event_p V_CALL
archWinPeek(arch_window_p wnd,vsize_t ofs)
{
	ui_event_p ptr;
	if(!eventDeqPeekBack(wnd->msg_que,ofs,&ptr))
		return NULL;
	return ptr;
}

vboolean V_CALL
archWinRemove(arch_window_p wnd,vsize_t ofs)
{
	if(!eventDeqPeekBack(wnd->msg_que,ofs,NULL))
		return false;
	wnd->msg_que = eventDeqRemoveBack(wnd->msg_que,ofs);
	return true;
}

vboolean V_CALL
ui_default_wnd_proc(arch_window_p aw,ui_event_p ev)
{
	switch(ev->type)
	{
		case ui_window_focus_in_event:
			aw->focused = true;
			if(aw->vidmode_on_activate != -1)
			{
				archWinSetVidMode(aw,aw->vidmode_on_activate);
				aw->vidmode_on_activate = -1;
			}
			break;
		case ui_window_focus_out_event:
			aw->focused = false;
			if(aw->current_vidmode != -1)
			{
				aw->vidmode_on_activate = aw->current_vidmode;
				archWinSetVidMode(aw,-1);
			}
			break;
		case ui_wm_event:
			if((ev->configure.wm_event == ui_wm_close) &&
					(aw->current_vidmode != -1))
				archWinSetVidMode(aw,-1);
			break;
		case ui_window_move_event:
			aw->x = ev->configure.x;
			aw->y = ev->configure.y;
			aw->width = ev->configure.width;
			aw->height = ev->configure.height;
			break;
		case ui_window_size_event:
			aw->x = ev->configure.x;
			aw->y = ev->configure.y;
			aw->width = ev->configure.width;
			aw->height = ev->configure.height;
			break;
		case ui_pointer_motion_event:
        	if(aw->auto_warp_pointer)
            {
            	s32_t cx = aw->width / 2;
            	s32_t cy = aw->height / 2;
				/* Avoid recursion */
				if(ev->client_x == cx && ev->client_y == cy)
					return true;
				/* Store deltas */
				ev->client_x -= cx;
				ev->client_y -= cy;
				ev->screen_x -= cx;
				ev->screen_y -= cy;
				archWinWarpPointer(aw,cx,cy);
            }
#ifdef	DISCARD_DUPLICATE_MOUSEMOVE
			if(aw->last_mx == ev->client_x && aw->last_my == ev->client_y)
				return true;
			aw->last_mx = ev->client_x;
			aw->last_my = ev->client_y;
#endif	/* DISCARD_DUPLICATE_MOUSEMOVE */
			break;
		default:
			break;
	}
	return false;
}

void V_CALL
ui_make_default_key_event(ui_key_event_p ev)
{
	ev->press = false;
	ev->scan = sc_unknown;
	ev->ch = 0;
	ev->unicode = 0;
}

void V_CALL
ui_set_configure_from_aw(arch_window_p aw,ui_configure_event_p ev)
{
	ev->focused = aw->focused;
	ev->visible = aw->visible;
	if(aw->visible)
	{
		ev->x = aw->x;
		ev->y = aw->y;
		ev->width = aw->width;
		ev->height = aw->height;
	}
	else
	{
		ev->x = ev->y = 0;
		ev->width = ev->height = 0;
	}
	ev->exposed_left = ev->exposed_top = 0;
	ev->exposed_right = ev->exposed_bottom = 0;
	ev->wm_event = ui_wm_unknown;
}

vec_t	V_CALL
ui_make_message_time(unsigned *start,unsigned current)
{
	unsigned delta1, delta2;
	if(!*start)
		*start = current; /* FIXME: from what to count the time ??? */
	if(*start <= current)
	{
		delta1 = current - *start;
		delta2 = 0;
	}
	else
	{
		/* overflow ! */
		unsigned last;
#ifdef _ARCH_64_
		last = 0xFFFFFFFFFFFFFFFF;
#else
		last = 0xFFFFFFFF;
#endif
		delta1 = last - *start;
		delta2 = current;
		/* FIXME: this is wrong */
		*start = current;
	}
	return (vec_t)0.001 * ((vec_t)delta1 + (vec_t)delta2);
}

#if 0

/* BEGIN gl_common.h */
#define	IF_NO_CONTEXT(ctx) \
	(ctx) = libvIsHandle(GetThreadData()->gl_context,caller_name, \
		gl_context_name,GL_CONTEXT_MAGIC); \
	if((ctx) == LIBV_INVALID_HANDLE)

/* BEGIN gl_common.c */
vboolean V_GLOBAL
uiPending()
{
	CALLER_NAME(uiPending)
	gl_context_p ctx;
	IF_NO_CONTEXT(ctx)
		return false;
	archWinPoll(ctx->wnd,false);
	return ctx->wnd->msg_que ? true : false;
}

void V_GLOBAL
uiFlushQueue(void)
{
	gl_context_p ctx;
	IF_NO_CONTEXT(ctx)
		return;
	archWinPoll(ctx->wnd,false);
	if(eventDeqCount(ctx->wnd->msg_que))
	{
		eventDeqFree(ctx->wnd->msg_que);
		ctx->wnd->msg_que = NULL;
	}
}

ui_event_p V_GLOBAL
uiPeekEvent(vsize_t offset_from_first_push)
{
	gl_context_p ctx;
	IF_NO_CONTEXT(ctx)
		return NULL;
	if(!eventDeqPeekBack(ctx->wnd->msg_que,offset_from_first_push,&ptr))
		return NULL;
	return ptr;
}

ui_event_p V_GLOBAL
uiPeekLastEvent(vsize_t offset_from_last_push)
{
	ui_event_p ptr;
	gl_context_p ctx;
	IF_NO_CONTEXT(ctx)
		return NULL;
	if(!eventDeqPeek(ctx->wnd->msg_que,offset_from_last_push,&ptr))
		return NULL;
	return ptr;
}

vboolean V_GLOBAL
uiRemoveEvent(vsize_t offset_from_first_push,ui_event_p ev_return)
{
	ui_event_p ptr;
	gl_context_p ctx;
	IF_NO_CONTEXT(ctx)
		return false;
	if(!eventDeqPeekBack(msg_que,offset_from_first_push,&ptr))
		return false;
	if(ev_return)
		memCopy(ev_return,ptr,sizeof(ui_event_t));
	msg_que = eventDeqRemoveBack(msg_que,offset_from_first_push);
	return true;
}

vboolean V_GLOBAL
uiRemoveLastEvent(vsize_t offset_from_last_push,ui_event_p ev_return)
{
	ui_event_p ptr;
	gl_context_p ctx;
	IF_NO_CONTEXT(ctx)
		return false;
	if(!eventDeqPeek(ctx->wnd->msg_que,offset_from_last_push,&ptr))
		return false;
	if(ev_return)
		memCopy(ev_return,ptr,sizeof(ui_event_t));
	ctx->wnd->msg_que =
		eventDeqRemove(ctx->wnd->msg_que,offset_from_last_push);
	return true;
}

vboolean V_GLOBAL
uiNextEvent(ui_event_p ev_return)
{
	gl_context_p ctx;
	IF_NO_CONTEXT(ctx)
		return false;
	archWinPoll(ctx->wnd,true);
	ctx->wnd->msg_que = eventDeqPopBack(ctx->wnd->msg_que,ev_return);
	return true;
}

#endif /* 0 */
