typedef float vec_t;
typedef int vboolean;
#define false 0
#define true (!false)

typedef enum /* ui_event_t -> type */
{
	ui_no_event,
	ui_key_event, /* key & button press/release */
	ui_pointer_motion_event, /* no special event */
	/* configure_window_event_t */
	ui_window_focus_in_event,
	ui_window_focus_out_event,
	ui_window_expose_event,
	ui_window_map_event,
	ui_window_unmap_event,
	ui_window_move_event,
	ui_window_size_event,
	ui_max_event
}	ui_event_type_t;

/*
 * Scancodes for "Windows" PC keyboard + 3-button mouse
 *
 * ui_key_event_t->scan
 */
typedef enum
{
	sc_unknown,

	sc_escape,
	sc_f1,
	sc_f2,
	sc_f3,
	sc_f4,
	sc_f5,
	sc_f6,
	sc_f7,
	sc_f8,
	sc_f9,
	sc_f10,
	sc_f11,
	sc_f12,
	sc_print,
	sc_scroll_lock,
	sc_pause,

	sc_grave,
	sc_1,
	sc_2,
	sc_3,
	sc_4,
	sc_5,
	sc_6,
	sc_7,
	sc_8,
	sc_9,
	sc_0,
	sc_minus,
	sc_equal,
	sc_backslash,
	sc_backspace,

	sc_tab,
	sc_q,
	sc_w,
	sc_e,
	sc_r,
	sc_t,
	sc_y,
	sc_u,
	sc_i,
	sc_o,
	sc_p,
	sc_lbracket,
	sc_rbracket,
	sc_enter,

	sc_caps_lock,
	sc_a,
	sc_s,
	sc_d,
	sc_f,
	sc_g,
	sc_h,
	sc_j,
	sc_k,
	sc_l,
	sc_semicolon,
	sc_apostrophe,

	sc_lshift,
	sc_z,
	sc_x,
	sc_c,
	sc_v,
	sc_b,
	sc_n,
	sc_m,
	sc_comma,
	sc_period,
	sc_slash,
	sc_rshift,

	sc_lcontrol,
	sc_lsuper,
	sc_lalt,
	sc_space,
	sc_ralt,
	sc_rsuper,
	sc_menu,
	sc_rcontrol,

	sc_insert,
	sc_home,
	sc_prior,
	sc_delete,
	sc_end,
	sc_next,

	sc_up,
	sc_down,
	sc_left,
	sc_right,

	sc_num_lock,
	sc_kp_slash,
	sc_kp_multiply,
	sc_kp_subtract,
	sc_kp_home,
	sc_kp_up,
	sc_kp_prior,
	sc_kp_add,
	sc_kp_left,
	sc_kp_begin,
	sc_kp_right,
	sc_kp_end,
	sc_kp_down,
	sc_kp_next,
	sc_kp_enter,
	sc_kp_insert,
	sc_kp_delete,
	
	sc_lbutton,
	sc_mbutton,
	sc_rbutton,

	sc_maxcode
} ui_scancode_t;

/*
 * ui_event_t->button
 */
#define	UI_LBUTTON_MASK	(1<<0)
#define	UI_MBUTTON_MASK (1<<1)
#define	UI_RBUTTON_MASK (1<<2)

/*
 * ui_event_t->state
 */
#define	UI_NUM_LOCK_MASK	(1<<0)	/* Mod2 */
#define	UI_CAPS_LOCK_MASK	(1<<1)
#define	UI_SCROLL_LOCK_MASK	(1<<2)	/* Mod5 */
#define	UI_SHIFT_MASK		(1<<3)
#define	UI_CONTROL_MASK		(1<<4)
#define	UI_ALT_MASK			(1<<5)	/* Mod1 */
#define	UI_WIN_MASK			(1<<6)	/* Mod4 */

typedef struct ui_key_event_s
{
	vboolean press;
	unsigned scan;
	unsigned ch;
	unsigned unicode;
}	ui_key_event_t, *ui_key_event_p;

typedef struct ui_configure_event_s
{
	vboolean focused;
	unsigned exposed_left, exposed_top, exposed_right, exposed_bottom;
	vboolean visible;
	int x, y;
	unsigned width, height;
}	ui_configure_event_t, *ui_configure_event_p;

typedef struct ui_event_s
{
	int		type;
	vec_t	time; /* time in secs since creation of window */
	int		client_x, client_y; /* mouse pointer position */
	int		screen_x, screen_y;
	unsigned button; /* mouse buttons */
	unsigned state; /* keyboard modifiers */
	ui_key_event_t key;
	ui_configure_event_t configure;
}	ui_event_t, *ui_event_p;

